%global _sharedstatedir /var/lib
Name: xymon
Version: 4.3.4
Release: 1%{?dist}.2
Group: Applications/System
URL: http://xymon.sourceforge.net/
License: GPLv2 with exceptions
Source: http://downloads.sourceforge.net/xymon/%{name}-%{version}%{?beta:-RC-%beta}.tar.gz
# Disable this patch when we upgrade. It will be included in the next release.
# See http://lists.xymon.com/pipermail/xymon/2011-August/032190.html for details.
Patch: xymon-4.3.4-infocolumn-crash.patch
Source1: xymon-init
Source2: xymon.logrotate
Source3: xymon-client.init
Source4: xymon.default
Source5: xymonlocal.te
Source6: xymonlocal.pp
Source7: xymonlocal.mod
Source8: xymon-apache.conf
Summary: Xymon network monitor
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: rrdtool ntp httpd fping
# Uncommented the BuildRequires below so that we can build in mock.
BuildRequires: openssl-devel
BuildRequires: pcre-devel
BuildRequires: rrdtool-devel
BuildRequires: openldap-devel
# Added the following:
BuildRequires: fping
Conflicts: xymon-client

%description
Xymon (previously known as Hobbit) is a system for monitoring 
your network servers and applications. This package contains 
the server side of the Xymon package.

%package client
Summary: Xymon client reporting data to the Xymon server
Group: Applications/System
Conflicts: xymon

%description client
This package contains a client for the Xymon (previously known
as Hobbit) monitor. Clients report data about the local system to 
the monitor, allowing it to check on the status of the system 
load, filesystem utilisation, processes that must be running etc.

%prep

%setup -q
%patch 
        USEXYMONPING=y \
        ENABLESSL=y \
        ENABLELDAP=y \
        ENABLELDAPSSL=y \
        XYMONUSER=%{name} \
        XYMONTOPDIR=%{_libdir}/%{name} \
        XYMONVAR=%{_sharedstatedir}/%{name} \
        XYMONHOSTURL=/%{name} \
        CGIDIR=%{_libdir}/%{name}/cgi-bin \
        XYMONCGIURL=/%{name}-cgi \
        SECURECGIDIR=%{_libdir}/%{name}/cgi-secure \
        SECUREXYMONCGIURL=/%{name}-seccgi \
        HTTPDGID=apache \
        XYMONLOGDIR=%{_localstatedir}/log/%{name} \
        XYMONHOSTNAME=localhost \
        XYMONHOSTIP=127.0.0.1 \
        MANROOT=%{_mandir} \
        INSTALLBINDIR=%{_libdir}/%{name}/server/bin \
        INSTALLETCDIR=%{_sysconfdir}/%{name} \
        INSTALLWEBDIR=%{_sysconfdir}/%{name}/web \
        INSTALLEXTDIR=%{_libdir}/%{name}/server/ext \
        INSTALLTMPDIR=%{_sharedstatedir}/%{name}/tmp \
        INSTALLWWWDIR=%{_sharedstatedir}/%{name}/www \
        ./configure

%build
    PKGBUILD=1 make

%install
    rm -rf %{buildroot}
       INSTALLROOT=%{buildroot} PKGBUILD=1 make install
    mkdir -p %{buildroot}/%{_initrddir}
    cp %{SOURCE1} %{buildroot}/%{_initrddir}/%{name}
    cp %{SOURCE3} %{buildroot}/%{_initrddir}/%{name}-client
    mkdir -p %{buildroot}/%{_sysconfdir}/logrotate.d
    cp %{SOURCE2} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}
    mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig
    cp %{SOURCE4} %{buildroot}/%{_sysconfdir}/sysconfig/%{name}
    mkdir -p %{buildroot}/%{_bindir}
    cd %{buildroot}/%{_bindir} && ln -sf ../lib/xymon/server/bin/{xymon,xymoncmd} .
    mkdir -p %{buildroot}/%{_sysconfdir}/httpd/conf.d
	# We are providing our own httpd.conf file since the example is broken.
	# WE should patch the source instead of overridding the makefile. It is only off
	# by one character and it gets modified to match the paths xymon uses.
    mv %{buildroot}%{_sysconfdir}/%{name}/xymon-apache.conf %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf
    # cp %{SOURCE8} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

	# This is stupid!! It creates tmp files in /tmp and unnecessary avc's. If anything we should symlink
	# it to /var/lib/xymon/tmp or something like that. I am not sure if having the client and server
	# write files to the same tmpdir would be problametic or not. Light testing says that the client
	# and server can write tmp files to the same tmp dir, as they seem to have different names on the tmp
	# files.  We moved them both to /var/lib/xymon/tmp
	# We need to make the tmp dir then delete it before symlinking it or else the server rpm does not do
	# the right thing.
	mkdir -p %{buildroot}%{_sharedstatedir}/%{name}/client/tmp
	rmdir %{buildroot}%{_sharedstatedir}/%{name}/client/tmp
    cd %{buildroot}%{_libdir}/%{name}/client && ln -sf %{_sharedstatedir}/%{name}/client/tmp tmp
    rmdir %{buildroot}%{_libdir}/%{name}/client/logs
    cd %{buildroot}%{_libdir}/%{name}/client && ln -sf ../../../..%{_localstatedir}/log/%{name} logs
    mv %{buildroot}%{_libdir}/%{name}/client/etc/xymonclient.cfg /tmp/xymonclient.cfg.$$
	cat /tmp/xymonclient.cfg.$$
    cat /tmp/xymonclient.cfg.$$ | sed -e 's!^XYMSRV=.*!include /var/run/xymonclient-runtime.cfg!' | grep -v "^XYMSERVERS=" >%{buildroot}%{_libdir}/%{name}/client/etc/xymonclient.cfg
    rm /tmp/xymonclient.cfg.$$

    # Added selinux stuff FIXME  Verify that the selinux stuff is still correct for el6
    mkdir -p %{buildroot}/%{_sysconfdir}/selinux/local-policy/
    install -m 644 %SOURCE5 %{buildroot}/%{_sysconfdir}/selinux/local-policy/
    install -m 644 %SOURCE6 %{buildroot}/%{_sysconfdir}/selinux/local-policy/
    install -m 644 %SOURCE7 %{buildroot}/%{_sysconfdir}/selinux/local-policy/

	# Install the docs.
	# Below is b0rked. Build process says docs are in /builddir/build/BUILD/xymon-4.3.4/docs
	# mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-%{version}/
# ls -lR *
	# install -m 644  %{buildroot}/%{name}-%{version}/{README,README.CLIENT,Changes*,COPYING,CREDITS,RELEASENOTES} %{buildroot}%{_defaultdocdir}/%{name}-%{version}/
	# install -m 644 %{buildroot}/docs/* %{buildroot}%{_defaultdocdir}/%{name}-%{version}/
	

%clean
    rm -rf %{buildroot}


%pre
id xymon 1>/dev/null 2>&1
if [ $? -ne 0 ]
then
   groupadd xymon || true
   useradd -g xymon -c "Xymon user" -d %{_libdir}/%{name} %{name}
fi
if [ -e %{_localstatedir}/log/%{name}/xymonlaunch.pid -a -x /etc/init.d/xymon ]
then
    /etc/init.d/xymon stop || true
fi

%pre client
id xymon 1>/dev/null 2>&1
if [ $? -ne 0 ]
then
   groupadd xymon || true
   useradd -g xymon -c "Xymon systems Monitor" -d %{_libdir}/%{name} %{name}
fi
if [ -e %{_localstatedir}/log/%{name}/clientlaunch.pid -a -x /etc/init.d/xymon-client ]
then
    /etc/init.d/xymon-client stop || true
fi


%post
if [ "$1" -le "1" ] ; then # First install
    /sbin/service httpd reload
    /sbin/chkconfig --add %{name} 2>/dev/null || :
fi

# Install selinux policy
# Loosly taken from http://fedoraproject.org/wiki/PackagingDrafts/SELinux and
# http://www.city-fan.org/tips/BuildSeLinuxPolicyModules
if [ "$1" -le "1" ] ; then # First install
echo here comes post
    semodule -i %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

# Change the group and perms of /var/log/messages so that xymon can read them.
chgrp %{name} %{_localstatedir}/log/messages || :
chmod 0640 %{_localstatedir}/log/messages || :

# Rename the old style config files if they exist.
if [ -f /etc/xymon/bb-hosts ] ; then
	mv /etc/xymon/hosts.cfg /etc/xymon/hosts.cfg.rpmnew
	mv /etc/xymon/bb-hosts /etc/xymon/hosts.cfg
fi

if [ -f /etc/xymon/bbcombotest.cfg ] ; then
	mv /etc/xymon/combo.cfg /etc/xymon/combo.cfg.rpmnew
	mv /etc/xymon/bbcombotest.cfg /etc/xymon/combo.cfg
fi

if [ -f /etc/xymon/hobbit-alerts.cfg ] ; then
	mv /etc/xymon/alerts.cfg /etc/xymon/alerts.cfg.rpmnew
	mv /etc/xymon/hobbit-alerts.cfg /etc/xymon/alerts.cfg
fi

if [ -f /etc/xymon/hobbit-nkview.cfg ] ; then
	mv /etc/xymon/critical.cfg /etc/xymon/critical.cfg.rpmnew
	mv /etc/xymon/hobbit-nkview.cfg /etc/xymon/critical.cfg
fi

if [ -f /etc/xymon/hobbit-rrddefinitions.cfg ] ; then
	mv /etc/xymon/rrddefinitions.cfg /etc/xymon/rrddefinitions.cfg.rpmnew
	mv /etc/xymon/hobbit-rrddefinitions.cfg /etc/xymon/rrddefinitions.cfg
fi

if [ -f /etc/xymon/hobbitgraph.cfg ] ; then
	mv /etc/xymon/graphs.cfg /etc/xymon/graphs.cfg.rpmnew
	mv /etc/xymon/hobbitgraph.cfg /etc/xymon/graphs.cfg
fi

if [ -f /etc/xymon/hobbit-holidays.cfg ] ; then
	mv /etc/xymon/holidays.cfg /etc/xymon/holidays.cfg.rpmnew
	mv /etc/xymon/hobbit-holidays.cfg /etc/xymon/holidays.cfg
fi

if [ -f /etc/xymon/hobbit-clients.cfg ] ; then
	mv /etc/xymon/analysis.cfg /etc/xymon/analysis.cfg.rpmnew
	mv /etc/xymon/hobbit-clients.cfg /etc/xymon/analysis.cfg
fi

if [ -f /etc/xymon/hobbit-snmpmibs.cfg ] ; then
	mv /etc/xymon/snmpmibs.cfg /etc/xymon/snmpmibs.cfg.rpmnew
	mv /etc/xymon/hobbit-snmpmibs.cfg /etc/xymon/snmpmibs.cfg
fi

if [ -f /etc/xymon/bb-services ] ; then
	mv /etc/xymon/protocols.cfg /etc/xymon/protocols.cfg.rpmnew
	mv /etc/xymon/bb-services /etc/xymon/protocols.cfg
fi


%post client
if [ ! -f "%{_initrddir}/%{name}" ] ; then
    /sbin/chkconfig --add %{name}-client 2>/dev/null || :
fi

# Install selinux policy
# Loosly taken from http://fedoraproject.org/wiki/PackagingDrafts/SELinux and
# http://www.city-fan.org/tips/BuildSeLinuxPolicyModules
if [ "$1" -le "1" ] ; then # First install
echo here comes post client
    semodule -i %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

# Change the group and perms of /var/log/messages so that xymon can read them.
chgrp %{name} %{_localstatedir}/log/messages || :
chmod 0640 %{_localstatedir}/log/messages || :

%preun
if [ "$1" -lt "1" ] ; then # Final removal
    /sbin/service %{name} stop 2>/dev/null || :
    /sbin/chkconfig --del %{name} 2>/dev/null || :
fi

/sbin/chkconfig --del %{name} 2>/dev/null || :
chgrp root %{_localstatedir}/log/messages || :
chmod 0600 %{_localstatedir}/log/messages || :

# Uninstall the selinux module.
if [ "$1" -lt "1" ] ; then # Final removal
    semodule -r %{name}local 2>/dev/null || :
    semodule -b %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

%preun client
if [ "$1" -lt "1" ] ; then # Final removal
echo here comes postun client
    if [ ! -f "%{_initrddir}/%{name}" ] ; then
        /sbin/service %{name}-client stop 2>/dev/null || :
    fi
    /sbin/chkconfig --del %{name}-client 2>/dev/null || :
    chgrp root %{_localstatedir}/log/messages || :
    chmod 0600 %{_localstatedir}/log/messages || :
fi

# Uninstall the selinux module.
if [ "$1" -lt "1" ] ; then # Final removal
echo here comes postun client
    semodule -r %{name}local 2>/dev/null || :
    semodule -b %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

%postun
# Upgrade the selinux policy.
if [ "$1" -ge "1" ] ; then # Upgrade
echo here comes postun
    semodule -i %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
    if [ ! -f "%{_initrddir}/%{name}" ] ; then
        /sbin/service %{name}-client condrestart >/dev/null 2>&1 || :
    fi
fi

%postun client
# Upgrade the selinux policy.
if [ "$1" -ge "1" ] ; then # Upgrade
echo here comes postun client
    semodule -i %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
    if [ ! -f "%{_initrddir}/%{name}" ] ; then
        /sbin/service %{name}-client condrestart >/dev/null 2>&1 || :
    fi
fi

%files
%attr(-, root, root) %doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES docs/*
#attr(-, root, root) %{_defaultdocdir}/%{name}-%{version}/
%attr(644, root, root) %doc %{_mandir}/man*/*
%attr(644, root, root) %config %{_sysconfdir}/%{name}/*
%attr(644, root, root) %config %{_sysconfdir}/httpd/conf.d/xymon.conf
%attr(755, root, root) %dir %{_sysconfdir}/%{name} 
%attr(755, root, root) %dir %{_libdir}/%{name}/server/download
%attr(755, root, root) %dir %{_sysconfdir}/%{name}/web
%attr(755, xymon, xymon) %dir %{_localstatedir}/log/%{name}
%attr(755, root, root) %{_initrddir}/%{name}
# We need this file even for just the server.
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(644, root, root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%attr(-, root, root) %{_libdir}/%{name}
%attr(-, root, root) %{_bindir}/*
%attr(-, xymon, xymon) %{_sharedstatedir}/%{name}
%attr(775, xymon, apache) %dir %{_sharedstatedir}/%{name}/www/rep
%attr(775, xymon, apache) %dir %{_sharedstatedir}/%{name}/www/snap
%attr(755, xymon, xymon) %dir %{_libdir}/%{name}/client/ext
%attr(664, xymon, apache) %config %{_sysconfdir}/%{name}/critical.cfg
%attr(664, xymon, apache) %config %{_sysconfdir}/%{name}/critical.cfg.bak
%attr(4750, root, xymon) %{_libdir}/%{name}/server/bin/xymonping
%attr(750, root, xymon) %{_libdir}/%{name}/client/bin/logfetch
%attr(750, root, xymon) %{_libdir}/%{name}/client/bin/clientupdate

%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.te
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.pp
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.mod

%files client
#attr(-, root, root) %doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES
%attr(-, root, root) %{_defaultdocdir}/%{name}-%{version}/
%attr(-, xymon, xymon) %{_libdir}/%{name}/client
%attr(755, root, root) %{_initrddir}/%{name}-client
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(755, xymon, xymon) %dir %{_localstatedir}/log/%{name}
%attr(755, xymon, xymon) %dir %{_libdir}/%{name}/client/ext
%attr(750, root, xymon) %{_libdir}/%{name}/client/bin/logfetch
%attr(750, root, xymon) %{_libdir}/%{name}/client/bin/clientupdate

%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.te
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.pp
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.mod

%changelog
* Sat Aug 09 2011 Tom Diehl <mock@tntechs.com> 4.3.4-1.tnt.2
- Minor changes to the tmp paths so that the symlinks are correct.

* Sat Aug 08 2011 Tom Diehl <mock@tntechs.com> 4.3.4-1.tnt.1
- Inital release of xymon 4.3.4 for el5 and el6.

